# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/jboss-ejb3-cache/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion 1.0.0

Name:           jboss-ejb3-cache
Version:        1.0.0
Release:        4%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Cache
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-cache-1.0.0/
Source0:        jboss-ejb3-cache-1.0.0.tar.gz
Source1:        jboss-ejb3-cache-jpp-depmap.xml
Source2:        jboss-ejb3-cache-settings.xml
Source3:        jboss-ejb3-cache-component-info.xml
Patch0:         %{name}-pom.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jboss-parent
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  junit4
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  gnu-trove
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-log4j
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jboss-serialization
#BuildRequires:  jbossws-native

Requires:  java >= 0:1.5.0
Requires:  gnu-trove
Requires:  jboss-common-core
Requires:  jboss-common-logging-log4j
Requires:  jboss-ejb-3.0-api
Requires:  jboss-ejb3-build
Requires:  jboss-serialization
#Requires:  jbossws-native

%description
JBoss EJB cache.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 644 target/jboss-ejb3-cache.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss.ejb3 jboss-ejb3-cache %{namedversion} JPP %{name}
install -p -m 644 target/jboss-ejb3-cache-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
jar -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar -C target/site/apidocs/ .

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-cache.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-cache.pom
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-cache-javadoc.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-cache-sources.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}-javadoc.jar
%{_javadir}/%{name}-javadoc.jar
%{_javadir}/%{name}-%{version}-sources.jar
%{_javadir}/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Aug 28 2012 Alex Szczuczko <aszczucz@redhat.com> - 0:1.0.0-4
- Add pom.patch to use jboss-ejb3-build 1.0.13 and jboss-javaee 5.0.2
- Update depmap and add test failure ignore
- Change junit44 build dep to junit4

* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-3.4.1
- rebuilt

* Wed Apr 07 2010 Hui Wang <huwang@redhat.com> 0:1.0.0-3.4
- Rebuild

* Mon Dec 07 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-3.3
- Add javadoc and sources jar files to main package and repolib
- Remove jboss-parent.pom from sources

* Thu Oct 01 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-3.2
- Add pom.xml to repolib

* Tue Sep 1 2009 Yong Yang <yyang@redhat.com> 0:1.0.0-3.1
- replace jboss-ejb3-build.pom with (B)R jboss-ejb3-build
- add jboss-parent.pom for build

* Wed Jul 15 2009 Yong Yang <yyang@redhat.com> 0:1.0.0-2.1
- Import from JPP-6
- Change BR maven-shared-enforcer-rule-api to maven-enforcer-rule-api
- Change jboss-ejb3-build.pom location
- Comment (Build)Requires:  jbossws-native
- Add jpp-depmap for jboss-ejb-api, jboss-ejb3-build

* Thu Jul 09 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-2
- add repolib

* Fri Jul 03 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.0-1.jpp5
- first release
